﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Runtime.InteropServices;


namespace DemoGridding
{
    // Class for calling DemoContour.DLL
    public class Contour
    {

        [DllImport("DemoContour")]
        public static extern int ContourDelete();
        [DllImport("DemoContour")]
        public static extern int ContourCreate();
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetHDC(IntPtr hDC);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetLimits(double dXmin, double dYmin, double dXmax, double dYmax);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetLabelValue(double dValue);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasDrawContour(int nCount, out double dX, out double dY);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasDrawPolygonContour(int nCount, out double dX, out double dY);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetSize(int nWidth, int nHeight);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasAddMargins(int nLeft, int nTop, int nRight, int nBottom);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetFontHeight(int nHeight);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetFontFaceName(string sName);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetXYRate(int nXYRate);
        [DllImport("DemoContour")]
        public static extern double ContourCanvasCoordinateX(int lPixelX);
        [DllImport("DemoContour")]
        public static extern double ContourCanvasCoordinateY(int lPixelY);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasPixelX(double dX);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasPixelY(double dY);
        [DllImport("DemoContour")]
        public static extern int ContourLabelSetTransparent(int nCode);

        [DllImport("DemoContour")]
        public static extern int ContourAxisAdd(string sAxeType);
        [DllImport("DemoContour")]
        public static extern int ContourAxisDraw();
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetTitle(int nAxe, string sAxeType);
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetFontFaceName(int nAxe, string sFontName);
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetFontHeight(int nAxe, int nFontHeight);
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetintTick(int nAxe, int nYes);
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetAutoTicks(int nAxe, int nYes);
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetTicks(int nAxe, double dFirst, double dStep, int nCount);
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetAutoDecimalPlace(int nAxe, int nYes);
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetDecimalPlace(int nAxe, int nPlace);
        [DllImport("DemoContour")]
        public static extern int ContourAxisSetTitleColor(int nIndex, int nColor);
        [DllImport("DemoContour")]
        public static extern int ContourAxisCalculate();
        [DllImport("DemoContour")]
        public static extern int ContourAxisSimpleDraw();

        [DllImport("DemoContour")]
        public static extern int ContourCalculateContours(int i, out double d);
        [DllImport("DemoContour")]
        public static extern int ContourGridGetMinMax(out double dMin, out double dMax);
        [DllImport("DemoContour")]
        public static extern int ContourSetGridEx(int nX, int nY, out double aX, out double aY, out double aV, out int aT);
        [DllImport("DemoContour")]
        public static extern int ContourPolygonsGetContoursCount();
        [DllImport("DemoContour")]
        public static extern int ContourPolygonsGetPolylinesCount();
        [DllImport("DemoContour")]
        public static extern int ContourPolygonsGetLineParameter(int nI, out int lVerticesCount, out double dValue);
        [DllImport("DemoContour")]
        public static extern int ContourPolygonsGetLineColorIndex(int nI);
        [DllImport("DemoContour")]
        public static extern int ContourPolygonsGetPolylineParameter(int nI, out int lVerticesCount, out double dValue);
        [DllImport("DemoContour")]
        public static extern int ContourPolygonsGetContourVertices(int nI, out int lVerticesCount, out double aCoordX, out double aCoordY);
        [DllImport("DemoContour")]
        public static extern int ContourPolygonsGetPolylineVertices(int nI, out int lVerticesCount, out double aCoordX, out double aCoordY);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetLabelSuffix(string sSuffix);

        [DllImport("DemoContour")]
        public static extern int ContourColorScaleCreate();
        [DllImport("DemoContour")]
        public static extern int ContourColorScaleSetLimits(double dMin, double dMax);
        [DllImport("DemoContour")]
        public static extern int ContourColorScaleSetColorCount(int nCount);
        [DllImport("DemoContour")]
        public static extern int ContourColorScaleSetFontFaceName(string sFontName);
        [DllImport("DemoContour")]
        public static extern int ContourColorScaleSetFontHeight(int nHeight);
        [DllImport("DemoContour")]
        public static extern int ContourColorScaleSetColor(int nIndex, int nColor);
        [DllImport("DemoContour")]
        public static extern int ContourColorScaleSetLabelSuffix(string sSuffix);
        [DllImport("DemoContour")]
        public static extern int ContourColorScaleDraw();
        [DllImport("DemoContour")]
        public static extern int ContourCanvasSetPolygonColorIndex(int n);
        [DllImport("DemoContour")]
        public static extern int ContourColorScaleSetShowItemBoundaries(int nShow);

        [DllImport("DemoContour")]
        public static extern int ContourBitmapLoad(string sFileName);
        [DllImport("DemoContour")]
        public static extern int ContourBitmapDraw();
        [DllImport("DemoContour")]
        public static extern int ContourBitmapSetLocate(int nX1, int nY1, int nX2, int nY2, double dX1, double dY1, double dX2, double dY2);

        [DllImport("DemoContour")]
        public static extern int ContourCanvasMemoryDraw();
        [DllImport("DemoContour")]
        public static extern int ContourCanvasWriteToPNG(string sFileName);
        [DllImport("DemoContour")]
        public static extern int ContourCanvasWriteToJPG(string sFileName);

        [DllImport("DemoContour")]
        public static extern int ContourCreateTransparentLayer();
        [DllImport("DemoContour")]
        public static extern int ContourDrawTransparentLayer(int nAlpha);
    }


    public class Distance
    {

        [DllImport("DemoDistance")]
        public static extern int InvDstCreate();
        [DllImport("DemoDistance")]
        public static extern int InvDstDelete();
        [DllImport("DemoDistance")]
        public static extern int InvDstSetGrid(int nColumn, out double pCoordX, int nRow, out double pCoordY);
        [DllImport("DemoDistance")]
        public static extern int InvDstSetGridEx(int nColumn, out double pCoordX, int nRow, out double pCoordY, out int pTypes);
        [DllImport("DemoDistance")]
        public static extern int InvDstSetData(int n, out double pX, out double pY, out double pZ);
        [DllImport("DemoDistance")]
        public static extern int InvDstCalculate();
        [DllImport("DemoDistance")]
        public static extern int InvDstGetValues(out double dV);
        [DllImport("DemoDistance")]
        public static extern int InvDstCalculateInThread();
        [DllImport("DemoDistance")]
        public static extern int InvDstCancel();
        [DllImport("DemoDistance")]
        public static extern int InvDstIsFinish();
        [DllImport("DemoDistance")]
        public static extern int InvDstGetCurrentProgress();

        [DllImport("DemoDistance")]
        public static extern double InvDstGetSearchRadius();
        [DllImport("DemoDistance")]
        public static extern double InvDstSetSearchRadius(double dRadius);
        [DllImport("DemoDistance")]
        public static extern int InvDstGetNearestPoints();
        [DllImport("DemoDistance")]
        public static extern int InvDstSetNearestPoints(int lNearestCount);
        [DllImport("DemoDistance")]
        public static extern double InvDstGetPower();
        [DllImport("DemoDistance")]
        public static extern double InvDstSetPower(double dPower);
        [DllImport("DemoDistance")]
        public static extern double InvDstGetTolerance();
        [DllImport("DemoDistance")]
        public static extern double InvDstSetTolerance(double dTolerance);
        [DllImport("DemoDistance")]
        public static extern double InvDstSetPlateauRadius(double PlateauRadius);
        [DllImport("DemoDistance")]
        public static extern double InvDstSetMissingValue(double dMissingValue);

    }

    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }

    }
}